#include<bits/stdc++.h>
using namespace std;
const int maxn=1e6+7;
int a[maxn];
int n,k;
bool check(int mid) {
int br=0;
int curr=0;
for(int i=0; i<n; i++) {
     curr|=a[i];
       if((mid&curr)>=mid) {
          curr=0;
          br++;
      
       }
}
return br>=k;
}


int main() {
ios_base::sync_with_stdio(0);
cin.tie(0);
cout.tie(0);
cin>>n>>k;
for(int i=0; i<n; i++) {
      cin>>a[i];
}
int ans=0;
for(int i=31; i>=0; i--) {
    ans+=(1<<i);
    if(!check(ans)) {
          ans-=(1<<i);
    }
}
cout<<ans<<endl;

return 0;
}